Loading...
Searching...
No Matches
wayland::server::data_offer_t Class Reference

offer to transfer data More...

`#include <wayland-server-protocol.hpp>`

Inherits wayland::server::resource_t.

## Public Member Functions

std::function< void(uint32_t, std::string)> & | on_accept ()
| accept one of the offered mime types
std::function< void(std::string, int)> & | on_receive ()
| request that the data is transferred
std::function< void()> & | on_destroy ()
| destroy data offer
std::function< void()> & | on_finish ()
| the offer will no longer be used
std::function< void(data_device_manager_dnd_action, data_device_manager_dnd_action)> & | on_set_actions ()
| set the available/preferred drag-and-drop actions
void | offer (std::string const &mime_type, bool post=true)
| advertise offered mime type
void | source_actions (data_device_manager_dnd_action const &source_actions, bool post=true)
| notify the source-side available actions
bool | can_source_actions () const
| Check whether the source_actions function is available with the currently bound version of the protocol.
void | action (data_device_manager_dnd_action const &dnd_action, bool post=true)
| notify the selected action
bool | can_action () const
| Check whether the action function is available with the currently bound version of the protocol.
void | post_invalid_finish (std::string const &msg)
| Post error: finish request was called untimely.
void | post_invalid_action_mask (std::string const &msg)
| Post error: action mask contains invalid values.
void | post_invalid_action (std::string const &msg)
| Post error: action argument has an invalid value.
void | post_invalid_offer (std::string const &msg)
| Post error: offer doesn't accept this request.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
void | post_no_memory () const
uint32_t | get_id () const
client_t | get_client () const
unsigned int | get_version () const
std::string | get_class ()

## Static Public Attributes

static constexpr std::uint32_t | offer_since_version = 1
| Minimum protocol version required for the offer function.
static constexpr std::uint32_t | source_actions_since_version = 3
| Minimum protocol version required for the source_actions function.
static constexpr std::uint32_t | action_since_version = 3
| Minimum protocol version required for the action function.

## Detailed Description

offer to transfer data

A wl_data_offer represents a piece of data offered for transfer by another client (the source client). It is used by the copy-and-paste and drag-and-drop mechanisms. The offer describes the different mime types that the data can be converted to and provides the mechanism for transferring the data directly from the source client.

Definition at line 821 of file wayland-server-protocol.hpp.

## Member Function Documentation

## action()

void data_offer_t::action | ( | data_device_manager_dnd_action const & | dnd_action,
|  | bool | post = `true`
| ) |  |

notify the selected action

Parameters

  dnd_action | action selected by the compositor

This event indicates the action selected by the compositor after matching the source/destination side actions. Only one action (or none) will be offered here.

This event can be emitted multiple times during the drag-and-drop operation in response to destination side action changes through wl_data_offer.set_actions.

This event will no longer be emitted after wl_data_device.drop happened on the drag-and-drop destination, the client must honor the last action received, or the last preferred one set through wl_data_offer.set_actions when handling an "ask" action.

Compositors may also change the selected action on the fly, mainly in response to keyboard modifier changes during the drag-and-drop operation.

The most recent action received is always the valid one. Prior to receiving wl_data_device.drop, the chosen action may change (e.g. due to keyboard modifiers being pressed). At the time of receiving wl_data_device.drop the drag-and-drop destination must honor the last action received.

Action changes may still happen after wl_data_device.drop, especially on "ask" actions, where the drag-and-drop destination may choose another action afterwards. Action changes happening at this stage are always the result of inter-client negotiation, the compositor shall no longer be able to induce a different action.

Upon "ask" actions, it is expected that the drag-and-drop destination may potentially choose a different action and/or mime type, based on wl_data_offer.source_actions and finally chosen by the user (e.g. popping up a menu with the available options). The final wl_data_offer.set_actions and wl_data_offer.accept requests must happen before the call to wl_data_offer.finish.

Definition at line 1893 of file wayland-server-protocol.cpp.

## can_action()

bool data_offer_t::can_action | ( |  | ) | const

Check whether the action function is available with the currently bound version of the protocol.

Definition at line 1898 of file wayland-server-protocol.cpp.

## can_source_actions()

bool data_offer_t::can_source_actions | ( |  | ) | const

Check whether the source_actions function is available with the currently bound version of the protocol.

Definition at line 1888 of file wayland-server-protocol.cpp.

## get_class()

std::string wayland::server::resource_t::get_class | ( |  | ) |

inherited

Retrieve the interface name (class) of a resource object.

Returns
  Interface name of the resource object.

## get_client()

client_t wayland::server::resource_t::get_client | ( |  | ) | const

inherited

Get the associated client

Returns
  the client that owns the resource.

## get_id()

uint32_t wayland::server::resource_t::get_id | ( |  | ) | const

inherited

Get the internal ID of the resource

Returns
  the internal ID of the resource

## get_version()

unsigned int wayland::server::resource_t::get_version | ( |  | ) | const

inherited

Get interface version

Returns
  Interface version this resource has been constructed with.

## offer()

void data_offer_t::offer | ( | std::string const & | mime_type,
|  | bool | post = `true`
| ) |  |

advertise offered mime type

Parameters

  mime_type | offered mime type

Sent immediately after creating the wl_data_offer object. One event per offered mime type.

Definition at line 1878 of file wayland-server-protocol.cpp.

## on_accept()

std::function< void(uint32_t, std::string)> & data_offer_t::on_accept | ( |  | ) |

accept one of the offered mime types

Parameters

  serial | serial number of the accept request
  mime_type | mime type accepted by the client

Indicate that the client can accept the given mime type, or NULL for not accepted.

For objects of version 2 or older, this request is used by the client to give feedback whether the client can receive the given mime type, or NULL if none is accepted; the feedback does not determine whether the drag-and-drop operation succeeds or not.

For objects of version 3 or newer, this request determines the final result of the drag-and-drop operation. If the end result is that no mime types were accepted, the drag-and-drop operation will be cancelled and the corresponding drag source will receive wl_data_source.cancelled. Clients may still use this event in conjunction with wl_data_source.action for feedback.

Definition at line 1848 of file wayland-server-protocol.cpp.

## on_destroy()

std::function< void()> & data_offer_t::on_destroy | ( |  | ) |

destroy data offer

Destroy the data offer.

Definition at line 1860 of file wayland-server-protocol.cpp.

## on_finish()

std::function< void()> & data_offer_t::on_finish | ( |  | ) |

the offer will no longer be used

Notifies the compositor that the drag destination successfully finished the drag-and-drop operation.

Upon receiving this request, the compositor will emit wl_data_source.dnd_finished on the drag source client.

It is a client error to perform other requests than wl_data_offer.destroy after this one. It is also an error to perform this request after a NULL mime type has been set in wl_data_offer.accept or no action was received through wl_data_offer.action.

If wl_data_offer.finish request is received for a non drag and drop operation, the invalid_finish protocol error is raised.

Definition at line 1866 of file wayland-server-protocol.cpp.

## on_receive()

std::function< void(std::string, int)> & data_offer_t::on_receive | ( |  | ) |

request that the data is transferred

Parameters

  mime_type | mime type desired by receiver
  fd | file descriptor for data transfer

To transfer the offered data, the client issues this request and indicates the mime type it wants to receive. The transfer happens through the passed file descriptor (typically created with the pipe system call). The source client writes the data in the mime type representation requested and then closes the file descriptor.

The receiving client reads from the read end of the pipe until EOF and then closes its end, at which point the transfer is complete.

This request may happen multiple times for different mime types, both before and after wl_data_device.drop. Drag-and-drop destination clients may preemptively fetch data or examine it more closely to determine acceptance.

Definition at line 1854 of file wayland-server-protocol.cpp.

## on_set_actions()

std::function< void(data_device_manager_dnd_action, data_device_manager_dnd_action)> & data_offer_t::on_set_actions | ( |  | ) |

set the available/preferred drag-and-drop actions

Parameters

  dnd_actions | actions supported by the destination client
  preferred_action | action preferred by the destination client

Sets the actions that the destination side client supports for this operation. This request may trigger the emission of wl_data_source.action and wl_data_offer.action events if the compositor needs to change the selected action.

This request can be called multiple times throughout the drag-and-drop operation, typically in response to wl_data_device.enter or wl_data_device.motion events.

This request determines the final result of the drag-and-drop operation. If the end result is that no action is accepted, the drag source will receive wl_data_source.cancelled.

The dnd_actions argument must contain only values expressed in the wl_data_device_manager.dnd_actions enum, and the preferred_action argument must only contain one of those values set, otherwise it will result in a protocol error.

While managing an "ask" action, the destination drag-and-drop client may perform further wl_data_offer.receive requests, and is expected to perform one last wl_data_offer.set_actions request with a preferred action other than "ask" (and optionally wl_data_offer.accept) before requesting wl_data_offer.finish, in order to convey the action selected by the user. If the preferred action is not in the wl_data_offer.source_actions mask, an error will be raised.

If the "ask" action is dismissed (e.g. user cancellation), the client is expected to perform wl_data_offer.destroy right away.

This request can only be made on drag-and-drop offers, a protocol error will be raised otherwise.

Definition at line 1872 of file wayland-server-protocol.cpp.

## post_invalid_action()

void data_offer_t::post_invalid_action | ( | std::string const & | msg | ) |

Post error: action argument has an invalid value.

Definition at line 1913 of file wayland-server-protocol.cpp.

## post_invalid_action_mask()

void data_offer_t::post_invalid_action_mask | ( | std::string const & | msg | ) |

Post error: action mask contains invalid values.

Definition at line 1908 of file wayland-server-protocol.cpp.

## post_invalid_finish()

void data_offer_t::post_invalid_finish | ( | std::string const & | msg | ) |

Post error: finish request was called untimely.

Definition at line 1903 of file wayland-server-protocol.cpp.

## post_invalid_offer()

void data_offer_t::post_invalid_offer | ( | std::string const & | msg | ) |

Post error: offer doesn't accept this request.

Definition at line 1918 of file wayland-server-protocol.cpp.

## post_no_memory()

void wayland::server::resource_t::post_no_memory | ( |  | ) | const

inherited

Post "not enough memory" error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

## proxy_has_object()

bool wayland::server::resource_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## source_actions()

void data_offer_t::source_actions | ( | data_device_manager_dnd_action const & | source_actions,
|  | bool | post = `true`
| ) |  |

notify the source-side available actions

Parameters

  source_actions | actions offered by the data source

This event indicates the actions offered by the data source. It will be sent right after wl_data_device.enter, or anytime the source side changes its offered actions through wl_data_source.set_actions.

Definition at line 1883 of file wayland-server-protocol.cpp.

## Member Data Documentation

## action_since_version

constexpr std::uint32_t wayland::server::data_offer_t::action_since_version = 3

static constexpr

Minimum protocol version required for the action function.

Definition at line 1038 of file wayland-server-protocol.hpp.

## offer_since_version

constexpr std::uint32_t wayland::server::data_offer_t::offer_since_version = 1

static constexpr

Minimum protocol version required for the offer function.

Definition at line 973 of file wayland-server-protocol.hpp.

## source_actions_since_version

constexpr std::uint32_t wayland::server::data_offer_t::source_actions_since_version = 3

static constexpr

Minimum protocol version required for the source_actions function.

Definition at line 987 of file wayland-server-protocol.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-server-protocol.hpp
- obj-x86_64-linux-gnu/wayland-server-protocol.cpp